-- Differences with Spagic 2.0.0 --

-- Solve SPAGIC-153 BUGS
-- IF USING SPAGIC 2.0 spagic-mysql-oracle.ddl
-- IN SPAGIC 2.1 THIS IS NOT REQUIRED
ALTER TABLE process modify process_version varchar(20);

ALTER TABLE property MODIFY code varchar(200);

-- Differences with Spagic 2.1.0 --

ALTER TABLE transition_instance ADD COLUMN attachment_in int DEFAULT 0 AFTER transition_data;

ALTER TABLE transition_instance ADD COLUMN attachment_out int DEFAULT 0 AFTER attachment_in;

ALTER TABLE transition_instance MODIFY TRANSITION_DATA MEDIUMBLOB;

ALTER TABLE transition_instance ADD COLUMN transition_data_out MEDIUMBLOB AFTER TRANSITION_DATA;

ALTER TABLE process ADD COLUMN monitor_enabled BOOLEAN NOT NULL DEFAULT true AFTER `state`;

-- Tables for event handling --
Create table wait_data (
	id_wait Bigint(20) NOT NULL AUTO_INCREMENT,
	id_correlation Varchar(200) NOT NULL,
	wait_timestamp Timestamp NOT NULL,
	expiry_timestamp Timestamp NULL DEFAULT NULL,
	expiration_action Varchar(500),
	eventType Varchar(200) NOT NULL DEFAULT "GenericEvent",
	exchange Blob,
	signalUri Varchar(500),
	destinationUri Varchar(500),
 Primary Key (id_wait)) ENGINE = InnoDB;

Create table wait_data_attribute (
	id_wait_data_attribute Bigint NOT NULL AUTO_INCREMENT,
	id_wait Bigint NOT NULL,
	name Varchar(200) NOT NULL,
	att_value Varchar(500),
 Primary Key (id_wait_data_attribute)) ENGINE = InnoDB;

Alter table wait_data_attribute add Foreign Key (id_wait) references wait_data (id_wait) on delete  restrict on update  restrict;

-- Exceution Time ( AZ 09/07/2008 )
ALTER TABLE transition_instance ADD COLUMN transition_execution_time Bigint(20) DEFAULT NULL AFTER transition_end;
ALTER TABLE process_instance ADD COLUMN  executiontime Bigint(20) DEFAULT NULL AFTER enddate;

-- Ricalcola tempi di esecuzione
UPDATE process_instance
SET executiontime = TIMESTAMPDIFF(SECOND,startdate,enddate) * 1000;

-- Changes for Deploy Tool
ALTER TABLE attribute ADD CONSTRAINT UNIQUE name (name);


